package anim;

import javax.swing.JPanel;

public abstract class AnimatorPanel extends JPanel {
	private Thread exThread;
	private long time_bet_frames=40;
	private boolean paused=false;
	private boolean stopped=false;
	
	protected void executeThread() {
		exThread=new Thread() {
			public void run() {
				while(!stopped) {
					try {
					synchronized(this) {
	                while (paused) 
	                	wait();
	                }
					update();
					Thread.sleep(time_bet_frames);
					} catch (InterruptedException e) {
						continue;
					}
				}
			}
		} ;
		exThread.start();
	}

	public void StopMe() {
		stopped=true;
	}
	
	public void UnPauseMe() {
		paused=false;
		exThread.interrupt();
	}
	
	public void PauseMe() {
		paused=true;
	}
	
	public AnimatorPanel(long msec) {		
		time_bet_frames=msec;
		executeThread();
	}
	
	public AnimatorPanel() {		
		executeThread();
	}
	
	public abstract void update();
	
}